// LiteLoader-AIDS automatic generated
/// <reference path="c:\bdsplugin/dts/helperlib/src/index.d.ts"/> 


const { PAPI } = require("../../../GMLIB-LegacyRemoteCallApi/lib/BEPlaceholderAPI-JS");
const JSON5 = require('json5');
const GROUP = spark.mc.config.group;
const ADMINS = spark.mc.config.admins;

// 配置文件
const chatForwardingConfig = spark.getFileHelper('BetterChatForwarding');
const chatShieldConfig = spark.getFileHelper('JandLandCmsg');

// 初始化配置文件
chatForwardingConfig.initFile('config.json', {
    prefixConfig: {
        enable: true,
        prefix: "chat"
    },
    suffixConfig: {
        groupMsgSuffix_Enable: true,
        groupMsgSuffix: "喵",
        gameMsgSuffix_Enable: true,
        gameMsgSuffix: "喵"
    },
    PAPI_Config: {
        groupMsg_PAPI: true,
        gameMsg_PAPI: true
    },
    formatGroupMsg: "{pl_dim}|{pl_dv}|{pl_ping}ms|Lv{pl_lv}<{pl_name}> {msg}",
    formatGameMsg: "§6[群聊] §b{displayName} : §e{msg}"
});

let forwardingConfig = JSON5.parse(chatForwardingConfig.getFile('config.json'));
let shieldConfig = JSON5.parse(chatShieldConfig.getFile('config.json'));
const characterLimit = shieldConfig.chatMaxLength;
const prohibitedWords = shieldConfig.chatShield;

spark.on('message.group.normal', (event, sendReply) => {
    const { raw_message: message, group_id: groupId, user_id: userId } = event;
    try {
        if (groupId !== GROUP) return;

        const disNickname = event.sender.nickname.replace(/§[a-zA-Z0-9]/g, '');
        const playerXboxID = spark.mc.getXbox(userId);
        const displayName = playerXboxID ? `${playerXboxID}§d(${disNickname})§f` : disNickname;
        let pl;
        if (playerXboxID && mc.getPlayer(playerXboxID)) {
            pl = mc.getPlayer(playerXboxID);
        }
        let player_qq;
        if (playerXboxID && getXboxInfo(playerXboxID)) {
            player_qq = getXboxInfo(playerXboxID);
        }
        // 格式化CQ码并过滤掉§符号
        let formatted_message = formatCQMessage(message).replace(/§[a-zA-Z0-9]/g, '');
        if (formatted_message.length >= characterLimit) return;

        for (let i = 0; i < prohibitedWords.length; i++) {
            if (formatted_message.includes(prohibitedWords[i]) && ADMINS.includes(player_qq)) {
                sendReply(`你发送的对话含有敏感词，将不会转发到游戏内!`, true);
                return;
            }
        }

        if (forwardingConfig.prefixConfig.enable) {
            if (formatted_message.startsWith(forwardingConfig.prefixConfig.prefix)) {
                let chatMessage = forwardingConfig.formatGameMsg
                    .replace('{displayName}', displayName)
                    .replace('{msg}', formatted_message.replace(forwardingConfig.prefixConfig.prefix, ''));

                if (forwardingConfig.suffixConfig.gameMsgSuffix_Enable) {
                    broadcastMessage(chatMessage, forwardingConfig.suffixConfig.gameMsgSuffix, forwardingConfig.PAPI_Config.gameMsg_PAPI, pl);
                } else {
                    broadcastMessage(chatMessage, '', forwardingConfig.PAPI_Config.gameMsg_PAPI, pl);
                }
            }
        } else {
            let chatMessage = forwardingConfig.formatGameMsg
                .replace('{displayName}', displayName)
                .replace('{msg}', formatted_message);

            if (forwardingConfig.suffixConfig.gameMsgSuffix_Enable) {
                broadcastMessage(chatMessage, forwardingConfig.suffixConfig.gameMsgSuffix, forwardingConfig.PAPI_Config.gameMsg_PAPI, pl);
            } else {
                broadcastMessage(chatMessage, '', forwardingConfig.PAPI_Config.gameMsg_PAPI, pl);
            }
        }
    } catch (error) {
        handleError(error);
    }
});

spark.mc.on('onChat', (player, message) => {
    try {
        let player_qq;
        if (getXboxInfo(player.realName)) {
            player_qq = getXboxInfo(player.realName);
        }
        if (message.length >= characterLimit) {
            player.tell(`§c聊天字符过长，将不会转发到群聊!`);
            return;
        }

        for (let i = 0; i < prohibitedWords.length; i++) {
            if (message.includes(prohibitedWords[i]) && !ADMINS.includes(player_qq)) {
                player.tell(`§c你发送的对话含有敏感词，将不会转发到群聊!`);
                return;
            }
        }

        let formattedMessage = forwardingConfig.formatGroupMsg
            .replace('{pl_dim}', getPlayerDimension(player))
            .replace('{pl_dv}', getPlayerDevice(player))
            .replace('{pl_ping}', getPlayerPing(player))
            .replace('{pl_lv}', getPlayerLevel(player))
            .replace('{pl_name}', player.realName)
            .replace('{msg}', message)
            .replace(/§[a-zA-Z0-9]/g, '');

        if (forwardingConfig.suffixConfig.groupMsgSuffix_Enable) {
            groupSendMessage(formattedMessage, forwardingConfig.suffixConfig.groupMsgSuffix, forwardingConfig.PAPI_Config.groupMsg_PAPI, player);
        } else {
            groupSendMessage(formattedMessage, '', forwardingConfig.PAPI_Config.groupMsg_PAPI, player);
        }
    } catch (error) {
        handleError(error);
    }
});

function broadcastMessage(message, suffix, enablePAPI, player) {
    if (enablePAPI) {
        mc.broadcast(`${PAPI.translateString(message, player)} ${suffix}`);
    } else {
        mc.broadcast(`${message} ${suffix}`);
    }
}

function groupSendMessage(message, suffix, enablePAPI, player) {
    if (enablePAPI) {
        spark.QClient.sendGroupMsg(GROUP, `${PAPI.translateString(message, player)} ${suffix}`);
    } else {
        spark.QClient.sendGroupMsg(GROUP, `${message} ${suffix}`);
    }
}

function handleError(error) {
    logger.error(`Error: `, error);
    logger.error(`Message: ${error.message}`);
    logger.error(`Stack: ${error.stack}`);
}

function getPlayerPing(player) {
    return `${player.getDevice().avgPing}`;
}

function getPlayerDimension(player) {
    const dimensions = { 0: "主", 1: "下", 2: "末" };
    return `${dimensions[player.pos.dimid] || "未知"}`;
}

function getPlayerDevice(player) {
    const platforms = {
        Android: '安卓',
        iOS: 'iOS',
        UWP: 'Win',
        WIN10: 'Win10',
        Win32: 'Win32',
        TVOS: 'TVOS',
        Xbox: 'Xbox',
        PlayStation: 'PS',
        WindowsPhone: 'WP',
        OSX: 'Mac',
        Nintendo: 'Switch'
    };
    return `${platforms[player.getDevice().os] || "未知"}`;
}

function getPlayerLevel(player) {
    return `${player.getLevel()}`;
}

function getXboxInfo(XboxID) {
    let xboxID_JSON = JSON.parse(spark.getFileHelper('mc').getFile('xbox.json'));
    for (let qq in xboxID_JSON) {
        if (xboxID_JSON[qq] == XboxID) {
            return qq;
        }
    }
    return false;
}

function formatCQMessage(message) {
    const cqCodeRegex = /\[CQ:(\w+),([^\]]+)\]/g;

    return message.replace(cqCodeRegex, (match, type, params) => {
        const paramMap = {};
        params.split(',').forEach(param => {
            const [key, value] = param.split('=');
            paramMap[key] = value;
        });

        switch (type) {
            case 'at':
                if (paramMap.qq == "all") {
                    return `@全体成员`;
                } else {
                    if (spark.mc.getXbox(paramMap.qq) === undefined) {
                        return '@' + paramMap.qq;
                    } else {
                        return '@' + spark.mc.getXbox(paramMap.qq);
                    }
                }
            case 'face':
                return `[表情:${paramMap.id}]`;
            case 'record':
                return `[语音]`;
            case 'share':
                return `[分享: ${paramMap.title} - ${paramMap.url}]`;
            case 'image':
                return paramMap.file.endsWith('.gif') ? `[动画表情]` : `[图片.${paramMap.file.split('.')[1]}]`;
            case 'forward':
                return `[合并转发]`;
            case 'video':
                return `[视频]`;
            case 'reply':
                return `[回复]`;
            case 'redbag':
                return `[红包: ${paramMap.title}]`;
            case 'poke':
                return `[戳: ${paramMap.qq}]`;
            case 'gift':
                return `[礼物: ${paramMap.qq}, 类型: ${paramMap.id}]`;
            case 'json':
                return `[JSON消息]`;
            case 'file':
                return `[文件：${paramMap.file}]`;
            default:
                logger.warn(`未识别的CQ码格式: `, match);
                return match;
        }
    });
}